/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of MTwist.xs. Do not edit this file, edit MTwist.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "MTwist.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define NEED_newCONSTSUB
#define NEED_sv_2pv_flags
#include "ppport.h"

#if defined __GLIBC__ && defined __linux__
#  ifndef _GNU_SOURCE
#    define _GNU_SOURCE
#  endif
#include <unistd.h>
#include <sys/syscall.h>
#include <linux/random.h>
#endif

#include "mtwist/mtwist.c"
#include "mtwist/randistrs.c"

/* Some guesswork for older Perls */
#ifndef NVMANTBITS
  #if NVSIZE <= 4
    #define NVMANTBITS 23
  #elif NVSIZE <= 8
    #define NVMANTBITS 52
  #elif defined(USE_QUADMATH)
    #define NVMANTBITS 112
  #elif defined(__LDBL_MANT_DIG__)
    #define NVMANTBITS __LDBL_MANT_DIG__
  #else
    #define NVMANTBITS 64
  #endif
#endif

#ifdef UINT64_MAX
  #define HAS_UINT64_T 1
#else
  #define HAS_UINT64_T 0
#endif

#define MT_HAS_INT128 defined(UINT64_MAX) && defined(__SIZEOF_INT128__)
#define MT_USE_QUADMATH NVMANTBITS > 64 && defined(USE_QUADMATH)
#define MT_USE_LONG_DOUBLE NVMANTBITS > 53 && defined(HAS_LONG_DOUBLE) && defined(USE_LONG_DOUBLE)

typedef union {
  double dbl;
  char str[8];
  uint32_t i32[2];
#if HAS_UINT64_T
  uint64_t i64;
#endif
} int2dbl;

#define I2D_SIZE sizeof(int2dbl)

#if HAS_UINT64_T
/* based on libowfat */
static inline U8 fmt_uint64(char* dest, uint64_t u) {
  U8 len, len2;
  uint64_t tmp;

  /* count digits */
  for(len = 1, tmp = u; tmp > 9; tmp /= 10)
    len++;

  if (dest) {
    len2 = len;
    dest += len;
    do {
      *--dest = (char)((u%10) + '0');
      u /= 10;
    } while (--len2);
  }

  return len;
}

#if IVSIZE < 8
/* newSVpvf doesn't handle "%llu" correctly. */
static SV* svpv_uint64(uint64_t u) {
  SV* retval;
  char* buf;
  size_t length;
  const size_t bufsize = 24;

  dTHX;

  Newxc(buf, bufsize, char, char);
  if (!buf)
    return NULL;

  retval = newSV(0);
  if (!retval) {
    Safefree(buf);
    return NULL;
  }

  length = fmt_uint64(buf, u);

  sv_upgrade(retval, SVt_PV);
  SvCUR_set(retval, length);
  SvLEN_set(retval, bufsize);
  SvPV_set(retval, buf);
  SvPOK_only(retval);

  return retval;
}
#endif  /* IVSIZE < 8 */
#endif  /* UINT64_MAX */

#if MT_HAS_INT128
typedef unsigned __int128 mt_uint128_t;

static inline mt_uint128_t mts_u128rand(register mt_state*  state) {
  unsigned i;
  union u128 {
    uint32_t u32[4];
    mt_uint128_t u128;
  } rv;
  uint32_t* u32 = rv.u32 + 4;

  for (i = 4; i > 0; i--) {
    if (state->stateptr <= 0)
      mts_refresh(state);
    *--u32 = state->statevec[--state->stateptr];
    MT_TEMPER(*u32);
  }

  return rv.u128;
}

static inline mt_uint128_t mt_u128rand(void) {
  return mts_u128rand(&mt_default_state);
}

/* 128-bit division and modulo are very time-consuming because there is no
 * native 128-bit integer arithmetic. We speed it up a bit by dividing by 1e9
 * instead of 10.
 */
static inline void fmt_nsec(char* dest, uint64_t u) {
  if (dest && u < 1000000000) {
    do {
      *--dest = (char)((u%10) + '0');
      u /= 10;
    } while (u);
  }
}

static inline U8 fmt_uint128(char* dest, mt_uint128_t u) {
  U8 len, len2;
  mt_uint128_t tmp;
  uint64_t mod;

  /* count digits */
  for (len = 0, tmp = u; tmp > 999999999; tmp /= 1000000000)
    len += 9;
  len += fmt_uint64(NULL, (uint64_t)tmp);

  if (dest) {
    memset(dest, '0', len);
    len2 = len;
    dest += len;
    while (1) {
      mod = u % 1000000000;
      if (mod)
        fmt_nsec(dest, mod);

      len2 -= 9;
      if ((I8)len2 <= 0)
        break;

      dest -= 9;
      u /= 1000000000;
    }
  }

  return len;
}

static SV* svpv_uint128(mt_uint128_t u) {
  SV* retval;
  char* buf;
  size_t length;
  const size_t bufsize = 40;

  dTHX;

  Newxc(buf, bufsize, char, char);
  if (!buf)
    return NULL;

  retval = newSV(0);
  if (!retval) {
    Safefree(buf);
    return NULL;
  }

  length = fmt_uint128(buf, u);

  sv_upgrade(retval, SVt_PV);
  SvCUR_set(retval, length);
  SvLEN_set(retval, bufsize);
  SvPV_set(retval, buf);
  SvPOK_only(retval);

  return retval;
}
#endif

/*
 * We copy the seeds from an array reference to a buffer so that mtwist can
 * copy the buffer to another buffer. No wonder that computer power must double
 * every two years ...
 *
 *
 * We assume that mt_seeds[] has been initialized with zeros.
 */
static void get_seeds_from_av(AV* av_seeds, uint32_t* mt_seeds) {
  SSize_t i;
  SV** av_seed;
  uint32_t had_nz = 0;

  dTHX;

  /*
   * Two classic examples of badly chosen identifier names:
   * av_len() does not return the array length but the top array index.
   * MT_STATE_SIZE is not sizeof(mt_state) but the length of the state vector.
   */

  i = av_len(av_seeds);
  if (i >= MT_STATE_SIZE)
    i = MT_STATE_SIZE - 1;

  for (; i >= 0; i--)
    if ((av_seed = av_fetch(av_seeds, i, 0)))
      had_nz |= mt_seeds[i] = SvUV(*av_seed);

  if (! had_nz)
    croak("seedfull(): Need at least one non-zero seed value");
}

/*
 * We calculate clock_gettime() in nanoseconds or gettimeofday() in
 * microseconds XORed with a memory address and use the lower 32 bit as the
 * seed.
 */
static uint32_t timeseed(mt_state* state) {
  UV seed;
#ifdef CLOCK_MONOTONIC
  struct timespec ts;

  clock_gettime(CLOCK_MONOTONIC, &ts);
  seed = ts.tv_sec*1000000000 + ts.tv_nsec;
#else
  I32 return_count;

  /* Who invented those silly cryptic macro names? */
  dTHX;
  dSP;

  PUSHMARK(SP);
  return_count = call_pv("Time::HiRes::gettimeofday", G_ARRAY);

  if (return_count != 2)
    croak("Time::HiRes::gettimeofday() returned %d instead of 2 values",
          return_count);

  SPAGAIN;
  seed = POPu;
  seed += POPu * 1000000;
  PUTBACK;
#endif

  /* Hopefully Address Space Layout Randomization gives us some additional
     randomness. */
  seed ^= PTR2UV(&get_seeds_from_av);

  if (state)
    mts_seed32new(state, seed);
  else
    mt_seed32new(seed);

  return seed;
}

#ifdef SYS_getrandom
static inline int mrmt_getrandom(void *buf, size_t buflen, unsigned flags) {
#if defined(__GLIBC__) && ( __GLIBC__ > 2 || __GLIBC_MINOR__ > 24 )
  return getrandom(buf, buflen, flags);
#else
  return syscall(SYS_getrandom, buf, buflen, flags);
#endif
}
#endif

static inline uint32_t devseed(mt_state* state, bool want_goodseed) {
#ifdef SYS_getrandom
  uint32_t seed;
  unsigned flags = want_goodseed ? GRND_RANDOM : 0;
  while (mrmt_getrandom(&seed, sizeof(seed), flags) < 0) {}
  if (state)
    mts_seed32new(state, seed);
  else
    mt_seed32new(seed);
  return seed;
#else
  if (want_goodseed)
    return state ? mts_goodseed(state) : mt_goodseed();
  else
    return state ? mts_seed(state) : mt_seed();
#endif
}

static inline uint32_t fastseed(mt_state* state) {
#ifdef WIN32
  return timeseed(state);
#else
  return devseed(state, 0);
#endif
}

static inline uint32_t goodseed(mt_state* state) {
#ifdef WIN32
  return timeseed(state);
#else
  return devseed(state, 1);
#endif
}

static inline void bestseed(mt_state* state) {
#ifdef WIN32
  timeseed(state);
#else
  state ? mts_bestseed(state) : mt_bestseed();
#endif
}

static inline void seedfull(mt_state* state, AV* seeds) {
  uint32_t mt_seeds[MT_STATE_SIZE] = {0};

  get_seeds_from_av(seeds, mt_seeds);

  if (state)
    mts_seedfull(state, mt_seeds);
  else
    mt_seedfull(mt_seeds);
}

static inline uint32_t srand50c(mt_state* state, uint32_t* seed) {
  if (seed == NULL)
    return fastseed(state);

  if (state)
    mts_seed32new(state, (uint32_t)*seed);
  else
    mt_seed32new((uint32_t)*seed);

  return *seed;
}

static inline int2dbl rd_double(mt_state* state) {
  int2dbl i2d;

#if HAS_UINT64_T
  i2d.i64 = state ? mts_llrand(state) : mt_llrand();
#else
  if (state) {
    i2d.i32[0] = mts_lrand(state);
    i2d.i32[1] = mts_lrand(state);
  }
  else {
    i2d.i32[0] = mt_lrand();
    i2d.i32[1] = mt_lrand();
  }
#endif

  return i2d;
}

static SV* randstr(mt_state* state, size_t length) {
  size_t bufsize, i;
  int2dbl* buf;
  SV* retval;

  dTHX;

  if (length == 0)
    return newSVpvn("", 0);

  /* Make bufsize an integer multiple of I2D_SIZE */
  bufsize = length + ((-length) % I2D_SIZE);
  if (bufsize < length)
    return NULL;

  Newxc(buf, bufsize, char, int2dbl);
  if (!buf)
    return NULL;

  i = bufsize / I2D_SIZE;
  buf += i;
  do {
    *--buf = rd_double(state);
  } while (--i);

  retval = newSV(0);
  if (!retval) {
    Safefree(buf);
    return NULL;
  }

  sv_upgrade(retval, SVt_PV);
  SvCUR_set(retval, length);
  SvLEN_set(retval, bufsize);
  SvPV_set(retval, (char*)buf);
  SvPOK_only(retval);

  return retval;
}

static FILE* open_file_from_sv(SV* file_sv, char* mode, PerlIO** pio) {
  FILE* fh = NULL;

  dTHX;

  if (! SvOK(file_sv)) {
    /* file_sv is undef */
    warn("Filename or handle expected");
  }
  else if (SvROK(file_sv) && SvTYPE(SvRV(file_sv)) == SVt_PVGV) {
    /* file_sv is a Perl filehandle */
    *pio = IoIFP(sv_2io(file_sv));
    fh = PerlIO_exportFILE(*pio, NULL);
  }
  else {
    /* file_sv is a filename */
    fh = fopen(SvPV_nolen(file_sv), mode);
  }

  return fh;
}

static int savestate(mt_state* state, SV* file_sv) {
  PerlIO* pio = NULL;
  FILE* fh = NULL;
  int RETVAL = 0;

  dTHX;

  fh = open_file_from_sv(file_sv, "w", &pio);

  if (fh) {
    RETVAL = state ? mts_savestate(fh, state) : mt_savestate(fh);
    if (pio) {
      fflush(fh);
      PerlIO_releaseFILE(pio, fh);
    }
    else
      fclose(fh);
  }

  return RETVAL;
}

static int loadstate(mt_state* state, SV* file_sv) {
  PerlIO* pio = NULL;
  FILE* fh = NULL;
  int RETVAL = 0;

  dTHX;

  fh = open_file_from_sv(file_sv, "r", &pio);

  if (fh) {
    RETVAL = state ? mts_loadstate(fh, state) : mt_loadstate(fh);
    if (pio)
      PerlIO_releaseFILE(pio, fh);
    else
      fclose(fh);
  }

  return RETVAL;
}

static void set_state_from_sv(SV* sv_state, mt_state* state) {
  STRLEN len;

  dTHX;

  if (!SvPOK(sv_state))
    croak("State must be a string");

  len = SvCUR(sv_state);
  if (len != sizeof(mt_state))
    croak("Need exactly %d state bytes, not %d", sizeof(mt_state), len);

  *state = *(mt_state*)SvPV_nolen(sv_state);

  if (state->stateptr < 0 || state->stateptr > MT_STATE_SIZE) {
    warn("stateptr value %d outside valid range [0, %d], using 0 instead",
         state->stateptr, MT_STATE_SIZE);
    state->stateptr = 0;
  }
}


#line 519 "MTwist.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 663 "MTwist.c"

XS_EUPXS(XS_Math__Random__MTwist_new_state); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_new_state)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	mt_state *	RETVAL;
	char*	CLASS = (char *)SvPV_nolen(ST(0))
;
#line 516 "MTwist.xs"
    Newxz(RETVAL, 1, mt_state);
    if (RETVAL == NULL)
      croak("Could not allocate state memory");
#line 679 "MTwist.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
  sv_setref_pv(RETVALSV, CLASS, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "state");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mt_state*	state;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 525 "MTwist.xs"
    Safefree(state);
#line 712 "MTwist.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Random__MTwist_seed32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_seed32)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "state, seed");
    {
	UV	RETVAL;
	dXSTARG;
	mt_state*	state;
	uint32_t	seed = (uint32_t)SvUV(ST(1))
;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 530 "MTwist.xs"
    mts_seed32new(state, seed);
    RETVAL = seed;
#line 743 "MTwist.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__seed32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__seed32)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "seed");
    {
	UV	RETVAL;
	dXSTARG;
	uint32_t	seed = (uint32_t)SvUV(ST(0))
;
#line 538 "MTwist.xs"
    mt_seed32new(seed);
    RETVAL = seed;
#line 764 "MTwist.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_srand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_srand)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "state, seed= 0");
    {
	UV	RETVAL;
	dXSTARG;
	mt_state*	state;
	uint32_t	seed;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;

	if (items < 2)
	    seed = 0;
	else {
	    seed = (uint32_t)SvUV(ST(1))
;
	}
#line 546 "MTwist.xs"
    RETVAL = srand50c(state, items == 1 ? NULL : &seed);
#line 800 "MTwist.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__srand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__srand)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "seed= 0");
    {
	UV	RETVAL;
	dXSTARG;
	uint32_t	seed;

	if (items < 1)
	    seed = 0;
	else {
	    seed = (uint32_t)SvUV(ST(0))
;
	}
#line 553 "MTwist.xs"
    RETVAL = srand50c(NULL, items == 0 ? NULL : &seed);
#line 826 "MTwist.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_timeseed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_timeseed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "state");
    {
	UV	RETVAL;
	dXSTARG;
	mt_state*	state;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;

	RETVAL = timeseed(state);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__timeseed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__timeseed)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	UV	RETVAL;
	dXSTARG;
#line 563 "MTwist.xs"
    RETVAL = timeseed(NULL);
#line 871 "MTwist.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_fastseed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_fastseed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "state");
    {
	UV	RETVAL;
	dXSTARG;
	mt_state*	state;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;

	RETVAL = fastseed(state);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__fastseed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__fastseed)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	UV	RETVAL;
	dXSTARG;
#line 573 "MTwist.xs"
    RETVAL = fastseed(NULL);
#line 916 "MTwist.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_goodseed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_goodseed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "state");
    {
	UV	RETVAL;
	dXSTARG;
	mt_state*	state;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;

	RETVAL = goodseed(state);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__goodseed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__goodseed)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	UV	RETVAL;
	dXSTARG;
#line 583 "MTwist.xs"
    RETVAL = goodseed(NULL);
#line 961 "MTwist.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_bestseed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_bestseed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "state");
    {
	mt_state*	state;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;

	bestseed(state);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Random__MTwist__bestseed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__bestseed)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 593 "MTwist.xs"
    bestseed(NULL);
#line 1003 "MTwist.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Random__MTwist_seedfull); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_seedfull)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "state, seeds");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mt_state*	state;
	AV*	seeds;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    seeds = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Random::MTwist::seedfull",
				"seeds");
		}
	} STMT_END
;
#line 598 "MTwist.xs"
    seedfull(state, seeds);
#line 1046 "MTwist.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Random__MTwist__seedfull); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__seedfull)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "seeds");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	AV*	seeds;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    seeds = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Random::MTwist::_seedfull",
				"seeds");
		}
	} STMT_END
;
#line 603 "MTwist.xs"
    seedfull(NULL, seeds);
#line 1079 "MTwist.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Random__MTwist_irand32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_irand32)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "state");
    {
	SV *	RETVAL;
	mt_state*	state;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 611 "MTwist.xs"
#if IVSIZE >= 8
    if (ix)
      RETVAL = newSVuv(mts_llrand(state));
#elif defined(UINT64_MAX)
    if (ix)
      RETVAL = svpv_uint64(mts_llrand(state));
#else
    if (ix == 1)
      XSRETURN_UNDEF;
#endif
    else
      RETVAL = newSVuv(state ? mts_lrand(state) : mt_lrand());
#line 1118 "MTwist.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__irand32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__irand32)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 632 "MTwist.xs"
#if IVSIZE >= 8
    if (ix)
      RETVAL = newSVuv(mt_llrand());
#elif defined(UINT64_MAX)
    if (ix)
      RETVAL = svpv_uint64(mt_llrand());
#else
    if (ix == 1)
      XSRETURN_UNDEF;
#endif
    else
      RETVAL = newSVuv(mt_lrand());
#line 1148 "MTwist.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_irand128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_irand128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "state");
    {
	SV *	RETVAL;
	mt_state*	state;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 650 "MTwist.xs"
#if IVSIZE >= 16
    RETVAL = newSVuv(mts_u128rand(state));
#elif MT_HAS_INT128
    RETVAL = svpv_uint128(mts_u128rand(state));
#else
    XSRETURN_UNDEF;
#endif
#line 1182 "MTwist.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__irand128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__irand128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 663 "MTwist.xs"
#if IVSIZE >= 16
    RETVAL = newSVuv(mt_u128rand());
#elif MT_HAS_INT128
    RETVAL = svpv_uint128(mt_u128rand());
#else
    XSRETURN_UNDEF;
#endif
#line 1206 "MTwist.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_rand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_rand)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "state, bound= 0");
    {
	NV	RETVAL;
	dXSTARG;
	mt_state*	state;
	NV	bound;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;

	if (items < 2)
	    bound = 0;
	else {
	    bound = (NV)SvNV(ST(1))
;
	}
#line 678 "MTwist.xs"
    if (NVMANTBITS <= 32 || ix)
      RETVAL = mts_drand(state);
    else
#if NVMANTBITS <= 64
      RETVAL = mts_ldrand(state);
#else
      RETVAL = mts_lldrand(state);
#endif
    if (bound)
      RETVAL *= bound;
#line 1253 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__rand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__rand)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "bound= 0");
    {
	NV	RETVAL;
	dXSTARG;
	NV	bound;

	if (items < 1)
	    bound = 0;
	else {
	    bound = (NV)SvNV(ST(0))
;
	}
#line 696 "MTwist.xs"
    if (NVMANTBITS <= 32 || ix)
      RETVAL = mt_drand();
    else
#if NVMANTBITS <= 64
      RETVAL = mt_ldrand();
#else
      RETVAL = mt_lldrand();
#endif
    if (bound)
      RETVAL *= bound;
#line 1289 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_randstr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_randstr)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "state, length= I2D_SIZE");
    {
	SV *	RETVAL;
	mt_state*	state;
	STRLEN	length;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;

	if (items < 2)
	    length = I2D_SIZE;
	else {
	    length = (STRLEN)SvUV(ST(1))
;
	}
#line 713 "MTwist.xs"
    RETVAL = randstr(state, length);
#line 1324 "MTwist.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__randstr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__randstr)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "length= I2D_SIZE");
    {
	SV *	RETVAL;
	STRLEN	length;

	if (items < 1)
	    length = I2D_SIZE;
	else {
	    length = (STRLEN)SvUV(ST(0))
;
	}
#line 720 "MTwist.xs"
    RETVAL = randstr(NULL, length);
#line 1350 "MTwist.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#define RETURN_I2D(have_index) { \
  if (have_index) {              \
    switch(index) {              \
    case 0:                      \
      XSRETURN_NV(i2d.dbl);      \
    case 1:                      \
      if (IVSIZE >= 8)           \
        XSRETURN_UV(i2d.i64);    \
      else                       \
        XSRETURN_UNDEF;          \
    case 2:                      \
      XSRETURN_PVN(i2d.str, 8);  \
    default:                     \
      XSRETURN_UNDEF;            \
    }                            \
  }                              \
  else {                         \
    mPUSHn(i2d.dbl);             \
    if (GIMME_V == G_ARRAY) {    \
      EXTEND(SP, 2);             \
      if (IVSIZE >= 8)           \
        mPUSHu(i2d.i64);         \
      else                       \
        PUSHs(&PL_sv_undef);     \
      mPUSHp(i2d.str, 8);        \
    }                            \
  }                              \
}                                \


XS_EUPXS(XS_Math__Random__MTwist_rd_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_rd_double)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "state, index= 0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 756 "MTwist.xs"
    int2dbl i2d;
#line 1398 "MTwist.c"
	mt_state*	state;
	int	index;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;

	if (items < 2)
	    index = 0;
	else {
	    index = (int)SvIV(ST(1))
;
	}
#line 758 "MTwist.xs"
    i2d = rd_double(state);
    RETURN_I2D(items > 1);
#line 1420 "MTwist.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Random__MTwist__rd_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__rd_double)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "index= 0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 764 "MTwist.xs"
    int2dbl i2d;
#line 1438 "MTwist.c"
	int	index;

	if (items < 1)
	    index = 0;
	else {
	    index = (int)SvIV(ST(0))
;
	}
#line 766 "MTwist.xs"
    i2d = rd_double(NULL);
    RETURN_I2D(items != 0);
#line 1450 "MTwist.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Random__MTwist_rd_iuniform32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_rd_iuniform32)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "state, lower, upper");
    {
	IV	RETVAL;
	dXSTARG;
	mt_state*	state;
	IV	lower = (IV)SvIV(ST(1))
;
	IV	upper = (IV)SvIV(ST(2))
;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 775 "MTwist.xs"
#if IVSIZE >= 8
    if (ix)
      RETVAL = rds_liuniform(state, lower, upper);
#else
    if (ix == 1)
      XSRETURN_UNDEF;
#endif
    else
      RETVAL = rds_iuniform(state, (int32_t)lower, (int32_t)upper);
#line 1491 "MTwist.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__rd_iuniform32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__rd_iuniform32)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "lower, upper");
    {
	IV	RETVAL;
	dXSTARG;
	IV	lower = (IV)SvIV(ST(0))
;
	IV	upper = (IV)SvIV(ST(1))
;
#line 793 "MTwist.xs"
#if IVSIZE >= 8
    if (ix)
      RETVAL = rd_liuniform(lower, upper);
#else
    if (ix == 1)
      XSRETURN_UNDEF;
#endif
    else
      RETVAL = rd_iuniform((int32_t)lower, (int32_t)upper);
#line 1522 "MTwist.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_rd_uniform); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_rd_uniform)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "state, lower, upper");
    {
	NV	RETVAL;
	dXSTARG;
	mt_state*	state;
	NV	lower = (NV)SvNV(ST(1))
;
	NV	upper = (NV)SvNV(ST(2))
;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 810 "MTwist.xs"
    RETVAL = (ix == 0) ? rds_uniform(state, lower, upper)
                       : rds_luniform(state, lower, upper);
#line 1556 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__rd_uniform); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__rd_uniform)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "lower, upper");
    {
	NV	RETVAL;
	dXSTARG;
	NV	lower = (NV)SvNV(ST(0))
;
	NV	upper = (NV)SvNV(ST(1))
;
#line 820 "MTwist.xs"
    RETVAL = (ix == 0) ? rd_uniform(lower, upper)
                       : rd_luniform(lower, upper);
#line 1580 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_rd_exponential); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_rd_exponential)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "state, mean");
    {
	NV	RETVAL;
	dXSTARG;
	mt_state*	state;
	NV	mean = (NV)SvNV(ST(1))
;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 830 "MTwist.xs"
    RETVAL = (ix == 0) ? rds_exponential(state, mean)
                       : rds_lexponential(state, mean);
#line 1612 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__rd_exponential); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__rd_exponential)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "mean");
    {
	NV	RETVAL;
	dXSTARG;
	NV	mean = (NV)SvNV(ST(0))
;
#line 840 "MTwist.xs"
    RETVAL = (ix == 0) ? rd_exponential(mean)
                       : rd_lexponential(mean);
#line 1634 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_rd_erlang); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_rd_erlang)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "state, k, mean");
    {
	NV	RETVAL;
	dXSTARG;
	mt_state*	state;
	IV	k = (IV)SvIV(ST(1))
;
	NV	mean = (NV)SvNV(ST(2))
;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 850 "MTwist.xs"
    RETVAL = (ix == 0) ? rds_erlang(state, k, mean)
                       : rds_lerlang(state, k, mean);
#line 1668 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__rd_erlang); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__rd_erlang)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "k, mean");
    {
	NV	RETVAL;
	dXSTARG;
	int	k = (int)SvIV(ST(0))
;
	NV	mean = (NV)SvNV(ST(1))
;
#line 860 "MTwist.xs"
    RETVAL = (ix == 0) ? rd_erlang(k, mean)
                       : rd_lerlang(k, mean);
#line 1692 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_rd_weibull); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_rd_weibull)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "state, shape, scale");
    {
	NV	RETVAL;
	dXSTARG;
	mt_state*	state;
	NV	shape = (NV)SvNV(ST(1))
;
	NV	scale = (NV)SvNV(ST(2))
;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 872 "MTwist.xs"
    switch (ix) {
      case 0:  RETVAL = rds_weibull(state, shape, scale); break;
      case 1:  RETVAL = rds_lweibull(state, shape, scale); break;
      case 2:  RETVAL = rds_lognormal(state, shape, scale); break;
      default: RETVAL = rds_llognormal(state, shape, scale);
    }
#line 1730 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__rd_weibull); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__rd_weibull)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "shape, scale");
    {
	NV	RETVAL;
	dXSTARG;
	NV	shape = (NV)SvNV(ST(0))
;
	NV	scale = (NV)SvNV(ST(1))
;
#line 888 "MTwist.xs"
    switch (ix) {
      case 0:  RETVAL = rd_weibull(shape, scale); break;
      case 1:  RETVAL = rd_lweibull(shape, scale); break;
      case 2:  RETVAL = rd_lognormal(shape, scale); break;
      default: RETVAL = rd_llognormal(shape, scale);
    }
#line 1758 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_rd_normal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_rd_normal)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "state, mean, sigma");
    {
	NV	RETVAL;
	dXSTARG;
	mt_state*	state;
	NV	mean = (NV)SvNV(ST(1))
;
	NV	sigma = (NV)SvNV(ST(2))
;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 902 "MTwist.xs"
    RETVAL = (ix == 0) ? rds_normal(state, mean, sigma)
                       : rds_lnormal(state, mean, sigma);
#line 1792 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__rd_normal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__rd_normal)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "mean, sigma");
    {
	NV	RETVAL;
	dXSTARG;
	NV	mean = (NV)SvNV(ST(0))
;
	NV	sigma = (NV)SvNV(ST(1))
;
#line 912 "MTwist.xs"
    RETVAL = (ix == 0) ? rd_normal(mean, sigma)
                       : rd_lnormal(mean, sigma);
#line 1816 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_rd_triangular); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_rd_triangular)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "state, lower, upper, mode");
    {
	NV	RETVAL;
	dXSTARG;
	mt_state*	state;
	NV	lower = (NV)SvNV(ST(1))
;
	NV	upper = (NV)SvNV(ST(2))
;
	NV	mode = (NV)SvNV(ST(3))
;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 922 "MTwist.xs"
    RETVAL = (ix == 0) ? rds_triangular(state, lower, upper, mode)
                       : rds_ltriangular(state, lower, upper, mode);
#line 1852 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__rd_triangular); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__rd_triangular)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "lower, upper, mode");
    {
	NV	RETVAL;
	dXSTARG;
	NV	lower = (NV)SvNV(ST(0))
;
	NV	upper = (NV)SvNV(ST(1))
;
	NV	mode = (NV)SvNV(ST(2))
;
#line 932 "MTwist.xs"
    RETVAL = (ix == 0) ? rd_triangular(lower, upper, mode)
                       : rd_ltriangular(lower, upper, mode);
#line 1878 "MTwist.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_savestate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_savestate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "state, file_sv");
    {
	int	RETVAL;
	dXSTARG;
	mt_state*	state;
	SV*	file_sv = ST(1)
;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;

	RETVAL = savestate(state, file_sv);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__savestate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__savestate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "file_sv");
    {
	int	RETVAL;
	dXSTARG;
	SV*	file_sv = ST(0)
;
#line 943 "MTwist.xs"
    RETVAL = savestate(NULL, file_sv);
#line 1927 "MTwist.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_loadstate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_loadstate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "state, file_sv");
    {
	int	RETVAL;
	dXSTARG;
	mt_state*	state;
	SV*	file_sv = ST(1)
;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;

	RETVAL = loadstate(state, file_sv);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__loadstate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__loadstate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "file_sv");
    {
	int	RETVAL;
	dXSTARG;
	SV*	file_sv = ST(0)
;
#line 953 "MTwist.xs"
    RETVAL = loadstate(NULL, file_sv);
#line 1976 "MTwist.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_getstate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_getstate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "state");
    {
	SV *	RETVAL;
	mt_state*	state;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 960 "MTwist.xs"
    RETVAL = newSVpvn((char*)state, sizeof(mt_state));
#line 2003 "MTwist.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist__getstate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__getstate)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 967 "MTwist.xs"
    RETVAL = newSVpvn((char*)&mt_default_state, sizeof(mt_state));
#line 2021 "MTwist.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__MTwist_setstate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist_setstate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "state, sv_state");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mt_state*	state;
	SV*	sv_state = ST(1)
;

  SV* sv = ST(0);
  if (sv_isobject(sv)) {
    state = INT2PTR( mt_state *, SvUV((SV*)SvRV(sv)) );
    *state = *state; /* tell the compiler that state is not NULL */
  }
  else
    state = NULL
;
#line 974 "MTwist.xs"
    set_state_from_sv(sv_state, state);
#line 2052 "MTwist.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Random__MTwist__setstate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__MTwist__setstate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_state");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	sv_state = ST(0)
;
#line 979 "MTwist.xs"
    set_state_from_sv(sv_state, &mt_default_state);
#line 2072 "MTwist.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Math__Random__MTwist); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__Random__MTwist)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Math::Random::MTwist::new_state", XS_Math__Random__MTwist_new_state, file, "$");
        (void)newXSproto_portable("Math::Random::MTwist::DESTROY", XS_Math__Random__MTwist_DESTROY, file, "$");
        (void)newXSproto_portable("Math::Random::MTwist::seed32", XS_Math__Random__MTwist_seed32, file, "$$");
        (void)newXSproto_portable("Math::Random::MTwist::_seed32", XS_Math__Random__MTwist__seed32, file, "$");
        (void)newXSproto_portable("Math::Random::MTwist::srand", XS_Math__Random__MTwist_srand, file, "$;$");
        (void)newXSproto_portable("Math::Random::MTwist::_srand", XS_Math__Random__MTwist__srand, file, ";$");
        (void)newXSproto_portable("Math::Random::MTwist::timeseed", XS_Math__Random__MTwist_timeseed, file, "$");
        (void)newXSproto_portable("Math::Random::MTwist::_timeseed", XS_Math__Random__MTwist__timeseed, file, "");
        (void)newXSproto_portable("Math::Random::MTwist::fastseed", XS_Math__Random__MTwist_fastseed, file, "$");
        (void)newXSproto_portable("Math::Random::MTwist::_fastseed", XS_Math__Random__MTwist__fastseed, file, "");
        (void)newXSproto_portable("Math::Random::MTwist::goodseed", XS_Math__Random__MTwist_goodseed, file, "$");
        (void)newXSproto_portable("Math::Random::MTwist::_goodseed", XS_Math__Random__MTwist__goodseed, file, "");
        (void)newXSproto_portable("Math::Random::MTwist::bestseed", XS_Math__Random__MTwist_bestseed, file, "$");
        (void)newXSproto_portable("Math::Random::MTwist::_bestseed", XS_Math__Random__MTwist__bestseed, file, "");
        (void)newXSproto_portable("Math::Random::MTwist::seedfull", XS_Math__Random__MTwist_seedfull, file, "$$");
        (void)newXSproto_portable("Math::Random::MTwist::_seedfull", XS_Math__Random__MTwist__seedfull, file, "$");
        cv = newXSproto_portable("Math::Random::MTwist::irand", XS_Math__Random__MTwist_irand32, file, "$");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Math::Random::MTwist::irand32", XS_Math__Random__MTwist_irand32, file, "$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::irand64", XS_Math__Random__MTwist_irand32, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::_irand", XS_Math__Random__MTwist__irand32, file, "");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Math::Random::MTwist::_irand32", XS_Math__Random__MTwist__irand32, file, "");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::_irand64", XS_Math__Random__MTwist__irand32, file, "");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("Math::Random::MTwist::irand128", XS_Math__Random__MTwist_irand128, file, "$");
        (void)newXSproto_portable("Math::Random::MTwist::_irand128", XS_Math__Random__MTwist__irand128, file, "");
        cv = newXSproto_portable("Math::Random::MTwist::rand", XS_Math__Random__MTwist_rand, file, "$;$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::rand32", XS_Math__Random__MTwist_rand, file, "$;$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::_rand", XS_Math__Random__MTwist__rand, file, ";$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::_rand32", XS_Math__Random__MTwist__rand, file, ";$");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("Math::Random::MTwist::randstr", XS_Math__Random__MTwist_randstr, file, "$;$");
        (void)newXSproto_portable("Math::Random::MTwist::_randstr", XS_Math__Random__MTwist__randstr, file, ";$");
        (void)newXSproto_portable("Math::Random::MTwist::rd_double", XS_Math__Random__MTwist_rd_double, file, "$;$");
        (void)newXSproto_portable("Math::Random::MTwist::_rd_double", XS_Math__Random__MTwist__rd_double, file, ";$");
        cv = newXSproto_portable("Math::Random::MTwist::rd_iuniform", XS_Math__Random__MTwist_rd_iuniform32, file, "$$$");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Math::Random::MTwist::rd_iuniform32", XS_Math__Random__MTwist_rd_iuniform32, file, "$$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::rd_iuniform64", XS_Math__Random__MTwist_rd_iuniform32, file, "$$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_iuniform", XS_Math__Random__MTwist__rd_iuniform32, file, "$$");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_iuniform32", XS_Math__Random__MTwist__rd_iuniform32, file, "$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_iuniform64", XS_Math__Random__MTwist__rd_iuniform32, file, "$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::rd_luniform", XS_Math__Random__MTwist_rd_uniform, file, "$$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::rd_uniform", XS_Math__Random__MTwist_rd_uniform, file, "$$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_luniform", XS_Math__Random__MTwist__rd_uniform, file, "$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_uniform", XS_Math__Random__MTwist__rd_uniform, file, "$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::rd_exponential", XS_Math__Random__MTwist_rd_exponential, file, "$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::rd_lexponential", XS_Math__Random__MTwist_rd_exponential, file, "$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_exponential", XS_Math__Random__MTwist__rd_exponential, file, "$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_lexponential", XS_Math__Random__MTwist__rd_exponential, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::rd_erlang", XS_Math__Random__MTwist_rd_erlang, file, "$$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::rd_lerlang", XS_Math__Random__MTwist_rd_erlang, file, "$$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_erlang", XS_Math__Random__MTwist__rd_erlang, file, "$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_lerlang", XS_Math__Random__MTwist__rd_erlang, file, "$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::rd_llognormal", XS_Math__Random__MTwist_rd_weibull, file, "$$$");
        XSANY.any_i32 = 3;
        cv = newXSproto_portable("Math::Random::MTwist::rd_lognormal", XS_Math__Random__MTwist_rd_weibull, file, "$$$");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Math::Random::MTwist::rd_lweibull", XS_Math__Random__MTwist_rd_weibull, file, "$$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::rd_weibull", XS_Math__Random__MTwist_rd_weibull, file, "$$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_llognormal", XS_Math__Random__MTwist__rd_weibull, file, "$$");
        XSANY.any_i32 = 3;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_lognormal", XS_Math__Random__MTwist__rd_weibull, file, "$$");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_lweibull", XS_Math__Random__MTwist__rd_weibull, file, "$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_weibull", XS_Math__Random__MTwist__rd_weibull, file, "$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::rd_lnormal", XS_Math__Random__MTwist_rd_normal, file, "$$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::rd_normal", XS_Math__Random__MTwist_rd_normal, file, "$$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_lnormal", XS_Math__Random__MTwist__rd_normal, file, "$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_normal", XS_Math__Random__MTwist__rd_normal, file, "$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::rd_ltriangular", XS_Math__Random__MTwist_rd_triangular, file, "$$$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::rd_triangular", XS_Math__Random__MTwist_rd_triangular, file, "$$$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_ltriangular", XS_Math__Random__MTwist__rd_triangular, file, "$$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Math::Random::MTwist::_rd_triangular", XS_Math__Random__MTwist__rd_triangular, file, "$$$");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("Math::Random::MTwist::savestate", XS_Math__Random__MTwist_savestate, file, "$$");
        (void)newXSproto_portable("Math::Random::MTwist::_savestate", XS_Math__Random__MTwist__savestate, file, "$");
        (void)newXSproto_portable("Math::Random::MTwist::loadstate", XS_Math__Random__MTwist_loadstate, file, "$$");
        (void)newXSproto_portable("Math::Random::MTwist::_loadstate", XS_Math__Random__MTwist__loadstate, file, "$");
        (void)newXSproto_portable("Math::Random::MTwist::getstate", XS_Math__Random__MTwist_getstate, file, "$");
        (void)newXSproto_portable("Math::Random::MTwist::_getstate", XS_Math__Random__MTwist__getstate, file, "");
        (void)newXSproto_portable("Math::Random::MTwist::setstate", XS_Math__Random__MTwist_setstate, file, "$$");
        (void)newXSproto_portable("Math::Random::MTwist::_setstate", XS_Math__Random__MTwist__setstate, file, "$");

    /* Initialisation Section */

#line 982 "MTwist.xs"
{
  HV *stash;

  stash = gv_stashpv("Math::Random::MTwist", TRUE);
  newCONSTSUB(stash, "HAS_UINT64_T", newSViv(HAS_UINT64_T));
  newCONSTSUB(stash, "NVMANTBITS",   newSViv(NVMANTBITS));
}

#line 2236 "MTwist.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

